/* -*-	Mode:C++; c-basic-offset:8; tab-width:8; indent-tabs-mode:t -*- */
/*
# Copyright (c) 2000-2001 by the University of Southern California.
# All rights reserved.
#
# Permission to use, copy, modify, and distribute this software and its
# documentation in source and binary forms for non-commercial purposes and
# without fee is hereby granted, provided that the above copyright notice
# appear in all copies and that both the copyright notice and this permission
# notice appear in supporting documentation, and that any documentation,
# advertising materials, and other materials related to such distribution and
# use acknowledge that the software was developed by the University of
# Southern California, Information Sciences Institute.  The name of the
# University may not be used to endorse or promote products derived from this
# software without specific prior written permission.
#
# THE UNIVERSITY OF SOUTHERN CALIFORNIA MAKES NO REPRESENTATIONS ABOUT THE
# SUITABILITY OF THIS SOFTWARE FOR ANY PURPOSE.  THIS SOFTWARE IS PROVIDED "AS
# IS" AND WITHOUT ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, WITHOUT
# LIMITATION, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
# PARTICULAR PURPOSE.
#
# Other copyrights might apply to parts of this software and are so noted when
# applicable.
# ----------------------------------------------------------------------------
#
# Primary author: Stephen Suryaputra
#                 September 1999
#This material is based upon work supported by the Defense Advanced Research
#Projects Agency Information Technology Office, (NGI Multicast Applications 
#and Architecture (NMAA-ADDON), ARPA Order No. H645, Program Code No. 9A20, 
#Issued by DARPA/CMD under Contract No. MDA972-99-C-0022.
*/

#ifndef FLOW_CONVERTER_H
#define FLOW_CONVERTER_H

#include "packet.h"
#include "ip.h"
#include "connector.h"

class FlowConverter : public Connector {
public:
	FlowConverter() {
		bind("off_ip_", &off_ip_);
		out_fid_ = -1;
		allocated_ = false;
	}

	int out_flowid() { return out_fid_; }
	bool& allocated() { return allocated_; }

	void setTarget(NsObject *t) { target_ = t; }

	int convertTo(int new_fid)
	{
		out_fid_ = new_fid;
		return (1);
	}

	void recv(Packet* p, Handler* h) {
		hdr_ip* iph = (hdr_ip*)p->access(off_ip_);
//		Tcl& tcl = Tcl::instance();
//		tcl.evalf("[Simulator instance] now");
//		printf("%s: ", tcl.result());
//		printf("%s (%d->%d) \n",name(), 
//		        iph->flowid(), out_fid_);
		iph->flowid() = out_fid_;
		send(p, h);
	}
protected:
	int off_ip_;
	int out_fid_;
	bool allocated_;
};

#endif
