#ifndef _NET_INTERFACE_H
#define _NET_INTERFACE_H
/*
* net-interface.cc
* Copyright (C) 1997 by USC/ISI
* All rights reserved.
*
* Redistribution and use in source and binary forms are permitted
* provided that the above copyright notice and this paragraph are
* duplicated in all such forms and that any documentation, advertising
* materials, and other materials related to such distribution and use
* acknowledge that the software was developed by the University of
* Southern California, Information Sciences Institute.  The name of the
* University may not be used to endorse or promote products derived from
* this software without specific prior written permission.
*
* THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT ANY EXPRESS OR IMPLIED
* WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED WARRANTIES OF
* MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
*
* @(#) $Header: /auto/boreas/jade/pkamath/cvsroot/pow/ns-2.1b6/net-interface.h,v 1.3 2001/04/19 21:18:03 pkamath Exp $
*
* Ported by Polly Huang (USC/ISI), http://www-scf.usc.edu/~bhuang
*/
/*
 * Author of modifications: Stephen Suryaputra
 *                          September 1999
 * This material is based upon work supported by the Defense Advanced Research
 * Projects Agency Information Technology Office, (NGI Multicast Applications 
 * and Architecture (NMAA-ADDON), ARPA Order No. H645, Program Code No. 9A20, 
 * Issued by DARPA/CMD under Contract No. MDA972-99-C-0022.
*/

#include "connector.h"
#include "packet.h"
#include "trace.h"

class NetworkInterface : public Connector {
public:
	static int count;
	NetworkInterface() : intf_label_(-1) {
		bind("off_cmn_", &off_cmn_);
//		bind("intf_label_", &intf_label_);
		intf_label_=count;
		count++;	
	}
	NetworkInterface(int32_t lbl) : intf_label_(lbl) {
		bind("off_cmn_", &off_cmn_);
//		bind("intf_label_", &intf_label_);
		intf_label_=count;
		count++;	
	}
	int command(int argc, const char*const* argv);
	void recv(Packet* pkt, Handler* h);
	int32_t label() {
	return intf_label_; }
	int32_t intf_label() {
	return intf_label_; }
	void send(Packet* p, Handler* h);
	int32_t intf_label_;
};

#endif

