# Copyright (c) 2000-2001 by the University of Southern California.
# All rights reserved.
#
# Permission to use, copy, modify, and distribute this software and its
# documentation in source and binary forms for non-commercial purposes and
# without fee is hereby granted, provided that the above copyright notice
# appear in all copies and that both the copyright notice and this permission
# notice appear in supporting documentation, and that any documentation,
# advertising materials, and other materials related to such distribution and
# use acknowledge that the software was developed by the University of
# Southern California, Information Sciences Institute.  The name of the
# University may not be used to endorse or promote products derived from this
# software without specific prior written permission.
#
# THE UNIVERSITY OF SOUTHERN CALIFORNIA MAKES NO REPRESENTATIONS ABOUT THE
# SUITABILITY OF THIS SOFTWARE FOR ANY PURPOSE.  THIS SOFTWARE IS PROVIDED "AS
# IS" AND WITHOUT ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, WITHOUT
# LIMITATION, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
# PARTICULAR PURPOSE.
#
# Other copyrights might apply to parts of this software and are so noted when
# applicable.
# ----------------------------------------------------------------------------
#
# Primary author: Stephen Suryaputra
#                 September 1999

#This material is based upon work supported by the Defense Advanced Research
#Projects Agency Information Technology Office, (NGI Multicast Applications 
#and Architecture (NMAA-ADDON), ARPA Order No. H645, Program Code No. 9A20, 
#Issued by DARPA/CMD under Contract No. MDA972-99-C-0022.


source swift-node.tcl

set ns [new Simulator]
#set tf [open vbns.ns.tr w]
#set nf [open vbns.nam.tr w]
#$ns trace-all $tf
#$ns namtrace-all $nf
$ns color 0 blue
$ns color 1 red
$ns color 2 green
$ns color 3 yellow
$ns color 4 magenta
$ns color 5 cyan
$ns color 6 brown
$ns color 7 purple
$ns color 8 white


set num_of_switches 12
set run_time 10  

set SEJ_dom [$ns node]
set HAY_dom [$ns node]
set RTO_dom [$ns node]
set DNJ_dom [$ns node]
set DNG_dom [$ns node]
set HSJ_dom [$ns node]
set AST_dom [$ns node]
set NOR_dom [$ns node]
set CHT_dom [$ns node]
set WOR_dom [$ns node]
set PYM_dom [$ns node]
set WAE_dom [$ns node]

# setup switches

Simulator set node_factory_ SwiftNode
set SEJ [$ns node]
puts "SEJ: $SEJ"
set HAY [$ns node]
puts "HAY: $HAY"
set RTO [$ns node]
puts "RTO: $RTO"
set DNJ [$ns node]
puts "DNJ: $DNJ"
set DNG [$ns node]
puts "DNG: $DNG"
set HSJ [$ns node]
puts "HSJ: $HSJ"
set AST [$ns node]
puts "AST: $AST"
set NOR [$ns node]
puts "NOR: $NOR"
set CHT [$ns node]
puts "CHT: $CHT"
set WOR [$ns node]
puts "WOR: $WOR"
set PYM [$ns node]
puts "PYM: $PYM"
set WAE [$ns node]
puts "WAE: $WAE"

$ns duplex-link $SEJ_dom $SEJ 620Mb 5ms DropTail
$ns duplex-link $HAY_dom $HAY 620Mb 5ms DropTail
$ns duplex-link $RTO_dom $RTO 620Mb 5ms DropTail
$ns duplex-link $DNJ_dom $DNJ 620Mb 5ms DropTail
$ns duplex-link $DNG_dom $DNG 620Mb 5ms DropTail
$ns duplex-link $HSJ_dom $HSJ 620Mb 5ms DropTail
$ns duplex-link $AST_dom $AST 620Mb 5ms DropTail
$ns duplex-link $NOR_dom $NOR 620Mb 5ms DropTail
$ns duplex-link $CHT_dom $CHT 620Mb 5ms DropTail
$ns duplex-link $WOR_dom $WOR 620Mb 5ms DropTail
$ns duplex-link $PYM_dom $PYM 620Mb 5ms DropTail
$ns duplex-link $WAE_dom $WAE 620Mb 5ms DropTail

$ns duplex-link $SEJ $HAY 2048Mb 5ms DropTail
$ns duplex-link $SEJ $DNJ 2048Mb 5ms DropTail
$ns duplex-link $HAY $RTO 2048Mb 5ms DropTail
$ns duplex-link $HAY $DNJ 2048Mb 5ms DropTail
$ns duplex-link $RTO $HSJ 2048Mb 5ms DropTail
$ns duplex-link $HSJ $DNG 2048Mb 5ms DropTail
$ns duplex-link $HSJ $AST 2048Mb 5ms DropTail
$ns duplex-link $DNJ $DNG 2048Mb 5ms DropTail
$ns duplex-link $DNG $NOR 2048Mb 5ms DropTail
$ns duplex-link $NOR $CHT 2048Mb 5ms DropTail
$ns duplex-link $NOR $WOR 2048Mb 5ms DropTail
$ns duplex-link $NOR $PYM 2048Mb 5ms DropTail
$ns duplex-link $PYM $WAE 2048Mb 5ms DropTail
$ns duplex-link $PYM $AST 2048Mb 5ms DropTail
$ns duplex-link $AST $WAE 2048Mb 5ms DropTail

### set packet traces input ###
#
# calculate each exchange quota
# xmap = (
#    "AST" => "1",
#    "HSJ" => "2",
#    "RTO" => "3",
#    "HAY" => "4",
#    "DNJ" => "5",
#    "DNG" => "6",
#    "NOR" => "7",
#    "WOR" => "8",
#    "PYM" => "9",
# );


#Traffic from AST:
set AST_HSJ_traces [new Network/Pcap/File]
$AST_HSJ_traces open 0 nlanr.AST.HSJ.raw
set AST_HSJ_Trafgen [new Application/Traffic/TcpDump]
$AST_HSJ_Trafgen attach-tracefile $AST_HSJ_traces
set AST_HSJ_agent [new Agent]
set HSJ_AST_agent [new Agent/Null]
$AST_HSJ_Trafgen attach-agent $AST_HSJ_agent
$ns attach-agent $AST_dom $AST_HSJ_agent
$ns attach-agent $HSJ_dom $HSJ_AST_agent
$ns connect $AST_HSJ_agent $HSJ_AST_agent

$ns at 0.0 "$AST_HSJ_Trafgen start" 

set AST_RTO_traces [new Network/Pcap/File]
$AST_RTO_traces open 0 nlanr.AST.RTO.raw
set AST_RTO_Trafgen [new Application/Traffic/TcpDump]
$AST_RTO_Trafgen attach-tracefile $AST_RTO_traces
set AST_RTO_agent [new Agent]
set RTO_AST_agent [new Agent/Null]
$AST_RTO_Trafgen attach-agent $AST_RTO_agent
$ns attach-agent $AST_dom $AST_RTO_agent
$ns attach-agent $RTO_dom $RTO_AST_agent
$ns connect $AST_RTO_agent $RTO_AST_agent

$ns at 0.0 "$AST_RTO_Trafgen start" 

set AST_HAY_traces [new Network/Pcap/File]
$AST_HAY_traces open 0 nlanr.AST.HAY.raw
set AST_HAY_Trafgen [new Application/Traffic/TcpDump]
$AST_HAY_Trafgen attach-tracefile $AST_HAY_traces
set AST_HAY_agent [new Agent]
set HAY_AST_agent [new Agent/Null]
$AST_HAY_Trafgen attach-agent $AST_HAY_agent
$ns attach-agent $AST_dom $AST_HAY_agent
$ns attach-agent $HAY_dom $HAY_AST_agent
$ns connect $AST_HAY_agent $HAY_AST_agent

$ns at 0.0 "$AST_HAY_Trafgen start" 

set AST_DNJ_traces [new Network/Pcap/File]
$AST_DNJ_traces open 0 nlanr.AST.DNJ.raw
set AST_DNJ_Trafgen [new Application/Traffic/TcpDump]
$AST_DNJ_Trafgen attach-tracefile $AST_DNJ_traces
set AST_DNJ_agent [new Agent]
set DNJ_AST_agent [new Agent/Null]
$AST_DNJ_Trafgen attach-agent $AST_DNJ_agent
$ns attach-agent $AST_dom $AST_DNJ_agent
$ns attach-agent $DNJ_dom $DNJ_AST_agent
$ns connect $AST_DNJ_agent $DNJ_AST_agent

$ns at 0.0 "$AST_DNJ_Trafgen start" 

set AST_DNG_traces [new Network/Pcap/File]
$AST_DNG_traces open 0 nlanr.AST.DNG.raw
set AST_DNG_Trafgen [new Application/Traffic/TcpDump]
$AST_DNG_Trafgen attach-tracefile $AST_DNG_traces
set AST_DNG_agent [new Agent]
set DNG_AST_agent [new Agent/Null]
$AST_DNG_Trafgen attach-agent $AST_DNG_agent
$ns attach-agent $AST_dom $AST_DNG_agent
$ns attach-agent $DNG_dom $DNG_AST_agent
$ns connect $AST_DNG_agent $DNG_AST_agent

$ns at 0.0 "$AST_DNG_Trafgen start" 

set AST_NOR_traces [new Network/Pcap/File]
$AST_NOR_traces open 0 nlanr.AST.NOR.raw
set AST_NOR_Trafgen [new Application/Traffic/TcpDump]
$AST_NOR_Trafgen attach-tracefile $AST_NOR_traces
set AST_NOR_agent [new Agent]
set NOR_AST_agent [new Agent/Null]
$AST_NOR_Trafgen attach-agent $AST_NOR_agent
$ns attach-agent $AST_dom $AST_NOR_agent
$ns attach-agent $NOR_dom $NOR_AST_agent
$ns connect $AST_NOR_agent $NOR_AST_agent

$ns at 0.0 "$AST_NOR_Trafgen start" 

set AST_WOR_traces [new Network/Pcap/File]
$AST_WOR_traces open 0 nlanr.AST.WOR.raw
set AST_WOR_Trafgen [new Application/Traffic/TcpDump]
$AST_WOR_Trafgen attach-tracefile $AST_WOR_traces
set AST_WOR_agent [new Agent]
set WOR_AST_agent [new Agent/Null]
$AST_WOR_Trafgen attach-agent $AST_WOR_agent
$ns attach-agent $AST_dom $AST_WOR_agent
$ns attach-agent $WOR_dom $WOR_AST_agent
$ns connect $AST_WOR_agent $WOR_AST_agent

$ns at 0.0 "$AST_WOR_Trafgen start" 

set AST_PYM_traces [new Network/Pcap/File]
$AST_PYM_traces open 0 nlanr.AST.PYM.raw
set AST_PYM_Trafgen [new Application/Traffic/TcpDump]
$AST_PYM_Trafgen attach-tracefile $AST_PYM_traces
set AST_PYM_agent [new Agent]
set PYM_AST_agent [new Agent/Null]
$AST_PYM_Trafgen attach-agent $AST_PYM_agent
$ns attach-agent $AST_dom $AST_PYM_agent
$ns attach-agent $PYM_dom $PYM_AST_agent
$ns connect $AST_PYM_agent $PYM_AST_agent

$ns at 0.0 "$AST_PYM_Trafgen start" 

#Traffic from HSJ:
set HSJ_AST_traces [new Network/Pcap/File]
$HSJ_AST_traces open 0 nlanr.HSJ.AST.raw
set HSJ_AST_Trafgen [new Application/Traffic/TcpDump]
$HSJ_AST_Trafgen attach-tracefile $HSJ_AST_traces
set HSJ_AST_agent [new Agent]
set AST_HSJ_agent [new Agent/Null]
$HSJ_AST_Trafgen attach-agent $HSJ_AST_agent
$ns attach-agent $HSJ_dom $HSJ_AST_agent
$ns attach-agent $AST_dom $AST_HSJ_agent
$ns connect $HSJ_AST_agent $AST_HSJ_agent

$ns at 0.0 "$HSJ_AST_Trafgen start" 

set HSJ_RTO_traces [new Network/Pcap/File]
$HSJ_RTO_traces open 0 nlanr.HSJ.RTO.raw
set HSJ_RTO_Trafgen [new Application/Traffic/TcpDump]
$HSJ_RTO_Trafgen attach-tracefile $HSJ_RTO_traces
set HSJ_RTO_agent [new Agent]
set RTO_HSJ_agent [new Agent/Null]
$HSJ_RTO_Trafgen attach-agent $HSJ_RTO_agent
$ns attach-agent $HSJ_dom $HSJ_RTO_agent
$ns attach-agent $RTO_dom $RTO_HSJ_agent
$ns connect $HSJ_RTO_agent $RTO_HSJ_agent

$ns at 0.0 "$HSJ_RTO_Trafgen start" 

set HSJ_HAY_traces [new Network/Pcap/File]
$HSJ_HAY_traces open 0 nlanr.HSJ.HAY.raw
set HSJ_HAY_Trafgen [new Application/Traffic/TcpDump]
$HSJ_HAY_Trafgen attach-tracefile $HSJ_HAY_traces
set HSJ_HAY_agent [new Agent]
set HAY_HSJ_agent [new Agent/Null]
$HSJ_HAY_Trafgen attach-agent $HSJ_HAY_agent
$ns attach-agent $HSJ_dom $HSJ_HAY_agent
$ns attach-agent $HAY_dom $HAY_HSJ_agent
$ns connect $HSJ_HAY_agent $HAY_HSJ_agent

$ns at 0.0 "$HSJ_HAY_Trafgen start" 

set HSJ_DNJ_traces [new Network/Pcap/File]
$HSJ_DNJ_traces open 0 nlanr.HSJ.DNJ.raw
set HSJ_DNJ_Trafgen [new Application/Traffic/TcpDump]
$HSJ_DNJ_Trafgen attach-tracefile $HSJ_DNJ_traces
set HSJ_DNJ_agent [new Agent]
set DNJ_HSJ_agent [new Agent/Null]
$HSJ_DNJ_Trafgen attach-agent $HSJ_DNJ_agent
$ns attach-agent $HSJ_dom $HSJ_DNJ_agent
$ns attach-agent $DNJ_dom $DNJ_HSJ_agent
$ns connect $HSJ_DNJ_agent $DNJ_HSJ_agent

$ns at 0.0 "$HSJ_DNJ_Trafgen start" 

set HSJ_DNG_traces [new Network/Pcap/File]
$HSJ_DNG_traces open 0 nlanr.HSJ.DNG.raw
set HSJ_DNG_Trafgen [new Application/Traffic/TcpDump]
$HSJ_DNG_Trafgen attach-tracefile $HSJ_DNG_traces
set HSJ_DNG_agent [new Agent]
set DNG_HSJ_agent [new Agent/Null]
$HSJ_DNG_Trafgen attach-agent $HSJ_DNG_agent
$ns attach-agent $HSJ_dom $HSJ_DNG_agent
$ns attach-agent $DNG_dom $DNG_HSJ_agent
$ns connect $HSJ_DNG_agent $DNG_HSJ_agent

$ns at 0.0 "$HSJ_DNG_Trafgen start" 

set HSJ_NOR_traces [new Network/Pcap/File]
$HSJ_NOR_traces open 0 nlanr.HSJ.NOR.raw
set HSJ_NOR_Trafgen [new Application/Traffic/TcpDump]
$HSJ_NOR_Trafgen attach-tracefile $HSJ_NOR_traces
set HSJ_NOR_agent [new Agent]
set NOR_HSJ_agent [new Agent/Null]
$HSJ_NOR_Trafgen attach-agent $HSJ_NOR_agent
$ns attach-agent $HSJ_dom $HSJ_NOR_agent
$ns attach-agent $NOR_dom $NOR_HSJ_agent
$ns connect $HSJ_NOR_agent $NOR_HSJ_agent

$ns at 0.0 "$HSJ_NOR_Trafgen start" 

set HSJ_WOR_traces [new Network/Pcap/File]
$HSJ_WOR_traces open 0 nlanr.HSJ.WOR.raw
set HSJ_WOR_Trafgen [new Application/Traffic/TcpDump]
$HSJ_WOR_Trafgen attach-tracefile $HSJ_WOR_traces
set HSJ_WOR_agent [new Agent]
set WOR_HSJ_agent [new Agent/Null]
$HSJ_WOR_Trafgen attach-agent $HSJ_WOR_agent
$ns attach-agent $HSJ_dom $HSJ_WOR_agent
$ns attach-agent $WOR_dom $WOR_HSJ_agent
$ns connect $HSJ_WOR_agent $WOR_HSJ_agent

$ns at 0.0 "$HSJ_WOR_Trafgen start" 

set HSJ_PYM_traces [new Network/Pcap/File]
$HSJ_PYM_traces open 0 nlanr.HSJ.PYM.raw
set HSJ_PYM_Trafgen [new Application/Traffic/TcpDump]
$HSJ_PYM_Trafgen attach-tracefile $HSJ_PYM_traces
set HSJ_PYM_agent [new Agent]
set PYM_HSJ_agent [new Agent/Null]
$HSJ_PYM_Trafgen attach-agent $HSJ_PYM_agent
$ns attach-agent $HSJ_dom $HSJ_PYM_agent
$ns attach-agent $PYM_dom $PYM_HSJ_agent
$ns connect $HSJ_PYM_agent $PYM_HSJ_agent

$ns at 0.0 "$HSJ_PYM_Trafgen start" 

#Traffic from RTO:
set RTO_AST_traces [new Network/Pcap/File]
$RTO_AST_traces open 0 nlanr.RTO.AST.raw
set RTO_AST_Trafgen [new Application/Traffic/TcpDump]
$RTO_AST_Trafgen attach-tracefile $RTO_AST_traces
set RTO_AST_agent [new Agent]
set AST_RTO_agent [new Agent/Null]
$RTO_AST_Trafgen attach-agent $RTO_AST_agent
$ns attach-agent $RTO_dom $RTO_AST_agent
$ns attach-agent $AST_dom $AST_RTO_agent
$ns connect $RTO_AST_agent $AST_RTO_agent

$ns at 0.0 "$RTO_AST_Trafgen start" 

set RTO_HSJ_traces [new Network/Pcap/File]
$RTO_HSJ_traces open 0 nlanr.RTO.HSJ.raw
set RTO_HSJ_Trafgen [new Application/Traffic/TcpDump]
$RTO_HSJ_Trafgen attach-tracefile $RTO_HSJ_traces
set RTO_HSJ_agent [new Agent]
set HSJ_RTO_agent [new Agent/Null]
$RTO_HSJ_Trafgen attach-agent $RTO_HSJ_agent
$ns attach-agent $RTO_dom $RTO_HSJ_agent
$ns attach-agent $HSJ_dom $HSJ_RTO_agent
$ns connect $RTO_HSJ_agent $HSJ_RTO_agent

$ns at 0.0 "$RTO_HSJ_Trafgen start" 

set RTO_HAY_traces [new Network/Pcap/File]
$RTO_HAY_traces open 0 nlanr.RTO.HAY.raw
set RTO_HAY_Trafgen [new Application/Traffic/TcpDump]
$RTO_HAY_Trafgen attach-tracefile $RTO_HAY_traces
set RTO_HAY_agent [new Agent]
set HAY_RTO_agent [new Agent/Null]
$RTO_HAY_Trafgen attach-agent $RTO_HAY_agent
$ns attach-agent $RTO_dom $RTO_HAY_agent
$ns attach-agent $HAY_dom $HAY_RTO_agent
$ns connect $RTO_HAY_agent $HAY_RTO_agent

$ns at 0.0 "$RTO_HAY_Trafgen start" 

set RTO_DNJ_traces [new Network/Pcap/File]
$RTO_DNJ_traces open 0 nlanr.RTO.DNJ.raw
set RTO_DNJ_Trafgen [new Application/Traffic/TcpDump]
$RTO_DNJ_Trafgen attach-tracefile $RTO_DNJ_traces
set RTO_DNJ_agent [new Agent]
set DNJ_RTO_agent [new Agent/Null]
$RTO_DNJ_Trafgen attach-agent $RTO_DNJ_agent
$ns attach-agent $RTO_dom $RTO_DNJ_agent
$ns attach-agent $DNJ_dom $DNJ_RTO_agent
$ns connect $RTO_DNJ_agent $DNJ_RTO_agent

$ns at 0.0 "$RTO_DNJ_Trafgen start" 

set RTO_DNG_traces [new Network/Pcap/File]
$RTO_DNG_traces open 0 nlanr.RTO.DNG.raw
set RTO_DNG_Trafgen [new Application/Traffic/TcpDump]
$RTO_DNG_Trafgen attach-tracefile $RTO_DNG_traces
set RTO_DNG_agent [new Agent]
set DNG_RTO_agent [new Agent/Null]
$RTO_DNG_Trafgen attach-agent $RTO_DNG_agent
$ns attach-agent $RTO_dom $RTO_DNG_agent
$ns attach-agent $DNG_dom $DNG_RTO_agent
$ns connect $RTO_DNG_agent $DNG_RTO_agent

$ns at 0.0 "$RTO_DNG_Trafgen start" 

set RTO_NOR_traces [new Network/Pcap/File]
$RTO_NOR_traces open 0 nlanr.RTO.NOR.raw
set RTO_NOR_Trafgen [new Application/Traffic/TcpDump]
$RTO_NOR_Trafgen attach-tracefile $RTO_NOR_traces
set RTO_NOR_agent [new Agent]
set NOR_RTO_agent [new Agent/Null]
$RTO_NOR_Trafgen attach-agent $RTO_NOR_agent
$ns attach-agent $RTO_dom $RTO_NOR_agent
$ns attach-agent $NOR_dom $NOR_RTO_agent
$ns connect $RTO_NOR_agent $NOR_RTO_agent

$ns at 0.0 "$RTO_NOR_Trafgen start" 

set RTO_WOR_traces [new Network/Pcap/File]
$RTO_WOR_traces open 0 nlanr.RTO.WOR.raw
set RTO_WOR_Trafgen [new Application/Traffic/TcpDump]
$RTO_WOR_Trafgen attach-tracefile $RTO_WOR_traces
set RTO_WOR_agent [new Agent]
set WOR_RTO_agent [new Agent/Null]
$RTO_WOR_Trafgen attach-agent $RTO_WOR_agent
$ns attach-agent $RTO_dom $RTO_WOR_agent
$ns attach-agent $WOR_dom $WOR_RTO_agent
$ns connect $RTO_WOR_agent $WOR_RTO_agent

$ns at 0.0 "$RTO_WOR_Trafgen start" 

set RTO_PYM_traces [new Network/Pcap/File]
$RTO_PYM_traces open 0 nlanr.RTO.PYM.raw
set RTO_PYM_Trafgen [new Application/Traffic/TcpDump]
$RTO_PYM_Trafgen attach-tracefile $RTO_PYM_traces
set RTO_PYM_agent [new Agent]
set PYM_RTO_agent [new Agent/Null]
$RTO_PYM_Trafgen attach-agent $RTO_PYM_agent
$ns attach-agent $RTO_dom $RTO_PYM_agent
$ns attach-agent $PYM_dom $PYM_RTO_agent
$ns connect $RTO_PYM_agent $PYM_RTO_agent

$ns at 0.0 "$RTO_PYM_Trafgen start" 

#Traffic from HAY:
set HAY_AST_traces [new Network/Pcap/File]
$HAY_AST_traces open 0 nlanr.HAY.AST.raw
set HAY_AST_Trafgen [new Application/Traffic/TcpDump]
$HAY_AST_Trafgen attach-tracefile $HAY_AST_traces
set HAY_AST_agent [new Agent]
set AST_HAY_agent [new Agent/Null]
$HAY_AST_Trafgen attach-agent $HAY_AST_agent
$ns attach-agent $HAY_dom $HAY_AST_agent
$ns attach-agent $AST_dom $AST_HAY_agent
$ns connect $HAY_AST_agent $AST_HAY_agent

$ns at 0.0 "$HAY_AST_Trafgen start" 

set HAY_HSJ_traces [new Network/Pcap/File]
$HAY_HSJ_traces open 0 nlanr.HAY.HSJ.raw
set HAY_HSJ_Trafgen [new Application/Traffic/TcpDump]
$HAY_HSJ_Trafgen attach-tracefile $HAY_HSJ_traces
set HAY_HSJ_agent [new Agent]
set HSJ_HAY_agent [new Agent/Null]
$HAY_HSJ_Trafgen attach-agent $HAY_HSJ_agent
$ns attach-agent $HAY_dom $HAY_HSJ_agent
$ns attach-agent $HSJ_dom $HSJ_HAY_agent
$ns connect $HAY_HSJ_agent $HSJ_HAY_agent

$ns at 0.0 "$HAY_HSJ_Trafgen start" 

set HAY_RTO_traces [new Network/Pcap/File]
$HAY_RTO_traces open 0 nlanr.HAY.RTO.raw
set HAY_RTO_Trafgen [new Application/Traffic/TcpDump]
$HAY_RTO_Trafgen attach-tracefile $HAY_RTO_traces
set HAY_RTO_agent [new Agent]
set RTO_HAY_agent [new Agent/Null]
$HAY_RTO_Trafgen attach-agent $HAY_RTO_agent
$ns attach-agent $HAY_dom $HAY_RTO_agent
$ns attach-agent $RTO_dom $RTO_HAY_agent
$ns connect $HAY_RTO_agent $RTO_HAY_agent

$ns at 0.0 "$HAY_RTO_Trafgen start" 

set HAY_DNJ_traces [new Network/Pcap/File]
$HAY_DNJ_traces open 0 nlanr.HAY.DNJ.raw
set HAY_DNJ_Trafgen [new Application/Traffic/TcpDump]
$HAY_DNJ_Trafgen attach-tracefile $HAY_DNJ_traces
set HAY_DNJ_agent [new Agent]
set DNJ_HAY_agent [new Agent/Null]
$HAY_DNJ_Trafgen attach-agent $HAY_DNJ_agent
$ns attach-agent $HAY_dom $HAY_DNJ_agent
$ns attach-agent $DNJ_dom $DNJ_HAY_agent
$ns connect $HAY_DNJ_agent $DNJ_HAY_agent

$ns at 0.0 "$HAY_DNJ_Trafgen start" 

set HAY_DNG_traces [new Network/Pcap/File]
$HAY_DNG_traces open 0 nlanr.HAY.DNG.raw
set HAY_DNG_Trafgen [new Application/Traffic/TcpDump]
$HAY_DNG_Trafgen attach-tracefile $HAY_DNG_traces
set HAY_DNG_agent [new Agent]
set DNG_HAY_agent [new Agent/Null]
$HAY_DNG_Trafgen attach-agent $HAY_DNG_agent
$ns attach-agent $HAY_dom $HAY_DNG_agent
$ns attach-agent $DNG_dom $DNG_HAY_agent
$ns connect $HAY_DNG_agent $DNG_HAY_agent

$ns at 0.0 "$HAY_DNG_Trafgen start" 

set HAY_NOR_traces [new Network/Pcap/File]
$HAY_NOR_traces open 0 nlanr.HAY.NOR.raw
set HAY_NOR_Trafgen [new Application/Traffic/TcpDump]
$HAY_NOR_Trafgen attach-tracefile $HAY_NOR_traces
set HAY_NOR_agent [new Agent]
set NOR_HAY_agent [new Agent/Null]
$HAY_NOR_Trafgen attach-agent $HAY_NOR_agent
$ns attach-agent $HAY_dom $HAY_NOR_agent
$ns attach-agent $NOR_dom $NOR_HAY_agent
$ns connect $HAY_NOR_agent $NOR_HAY_agent

$ns at 0.0 "$HAY_NOR_Trafgen start" 

set HAY_WOR_traces [new Network/Pcap/File]
$HAY_WOR_traces open 0 nlanr.HAY.WOR.raw
set HAY_WOR_Trafgen [new Application/Traffic/TcpDump]
$HAY_WOR_Trafgen attach-tracefile $HAY_WOR_traces
set HAY_WOR_agent [new Agent]
set WOR_HAY_agent [new Agent/Null]
$HAY_WOR_Trafgen attach-agent $HAY_WOR_agent
$ns attach-agent $HAY_dom $HAY_WOR_agent
$ns attach-agent $WOR_dom $WOR_HAY_agent
$ns connect $HAY_WOR_agent $WOR_HAY_agent

$ns at 0.0 "$HAY_WOR_Trafgen start" 

set HAY_PYM_traces [new Network/Pcap/File]
$HAY_PYM_traces open 0 nlanr.HAY.PYM.raw
set HAY_PYM_Trafgen [new Application/Traffic/TcpDump]
$HAY_PYM_Trafgen attach-tracefile $HAY_PYM_traces
set HAY_PYM_agent [new Agent]
set PYM_HAY_agent [new Agent/Null]
$HAY_PYM_Trafgen attach-agent $HAY_PYM_agent
$ns attach-agent $HAY_dom $HAY_PYM_agent
$ns attach-agent $PYM_dom $PYM_HAY_agent
$ns connect $HAY_PYM_agent $PYM_HAY_agent

$ns at 0.0 "$HAY_PYM_Trafgen start" 

#Traffic from DNJ:
set DNJ_AST_traces [new Network/Pcap/File]
$DNJ_AST_traces open 0 nlanr.DNJ.AST.raw
set DNJ_AST_Trafgen [new Application/Traffic/TcpDump]
$DNJ_AST_Trafgen attach-tracefile $DNJ_AST_traces
set DNJ_AST_agent [new Agent]
set AST_DNJ_agent [new Agent/Null]
$DNJ_AST_Trafgen attach-agent $DNJ_AST_agent
$ns attach-agent $DNJ_dom $DNJ_AST_agent
$ns attach-agent $AST_dom $AST_DNJ_agent
$ns connect $DNJ_AST_agent $AST_DNJ_agent

$ns at 0.0 "$DNJ_AST_Trafgen start" 

set DNJ_HSJ_traces [new Network/Pcap/File]
$DNJ_HSJ_traces open 0 nlanr.DNJ.HSJ.raw
set DNJ_HSJ_Trafgen [new Application/Traffic/TcpDump]
$DNJ_HSJ_Trafgen attach-tracefile $DNJ_HSJ_traces
set DNJ_HSJ_agent [new Agent]
set HSJ_DNJ_agent [new Agent/Null]
$DNJ_HSJ_Trafgen attach-agent $DNJ_HSJ_agent
$ns attach-agent $DNJ_dom $DNJ_HSJ_agent
$ns attach-agent $HSJ_dom $HSJ_DNJ_agent
$ns connect $DNJ_HSJ_agent $HSJ_DNJ_agent

$ns at 0.0 "$DNJ_HSJ_Trafgen start" 

set DNJ_RTO_traces [new Network/Pcap/File]
$DNJ_RTO_traces open 0 nlanr.DNJ.RTO.raw
set DNJ_RTO_Trafgen [new Application/Traffic/TcpDump]
$DNJ_RTO_Trafgen attach-tracefile $DNJ_RTO_traces
set DNJ_RTO_agent [new Agent]
set RTO_DNJ_agent [new Agent/Null]
$DNJ_RTO_Trafgen attach-agent $DNJ_RTO_agent
$ns attach-agent $DNJ_dom $DNJ_RTO_agent
$ns attach-agent $RTO_dom $RTO_DNJ_agent
$ns connect $DNJ_RTO_agent $RTO_DNJ_agent

$ns at 0.0 "$DNJ_RTO_Trafgen start" 

set DNJ_HAY_traces [new Network/Pcap/File]
$DNJ_HAY_traces open 0 nlanr.DNJ.HAY.raw
set DNJ_HAY_Trafgen [new Application/Traffic/TcpDump]
$DNJ_HAY_Trafgen attach-tracefile $DNJ_HAY_traces
set DNJ_HAY_agent [new Agent]
set HAY_DNJ_agent [new Agent/Null]
$DNJ_HAY_Trafgen attach-agent $DNJ_HAY_agent
$ns attach-agent $DNJ_dom $DNJ_HAY_agent
$ns attach-agent $HAY_dom $HAY_DNJ_agent
$ns connect $DNJ_HAY_agent $HAY_DNJ_agent

$ns at 0.0 "$DNJ_HAY_Trafgen start" 

set DNJ_DNG_traces [new Network/Pcap/File]
$DNJ_DNG_traces open 0 nlanr.DNJ.DNG.raw
set DNJ_DNG_Trafgen [new Application/Traffic/TcpDump]
$DNJ_DNG_Trafgen attach-tracefile $DNJ_DNG_traces
set DNJ_DNG_agent [new Agent]
set DNG_DNJ_agent [new Agent/Null]
$DNJ_DNG_Trafgen attach-agent $DNJ_DNG_agent
$ns attach-agent $DNJ_dom $DNJ_DNG_agent
$ns attach-agent $DNG_dom $DNG_DNJ_agent
$ns connect $DNJ_DNG_agent $DNG_DNJ_agent

$ns at 0.0 "$DNJ_DNG_Trafgen start" 

set DNJ_NOR_traces [new Network/Pcap/File]
$DNJ_NOR_traces open 0 nlanr.DNJ.NOR.raw
set DNJ_NOR_Trafgen [new Application/Traffic/TcpDump]
$DNJ_NOR_Trafgen attach-tracefile $DNJ_NOR_traces
set DNJ_NOR_agent [new Agent]
set NOR_DNJ_agent [new Agent/Null]
$DNJ_NOR_Trafgen attach-agent $DNJ_NOR_agent
$ns attach-agent $DNJ_dom $DNJ_NOR_agent
$ns attach-agent $NOR_dom $NOR_DNJ_agent
$ns connect $DNJ_NOR_agent $NOR_DNJ_agent

$ns at 0.0 "$DNJ_NOR_Trafgen start" 

set DNJ_WOR_traces [new Network/Pcap/File]
$DNJ_WOR_traces open 0 nlanr.DNJ.WOR.raw
set DNJ_WOR_Trafgen [new Application/Traffic/TcpDump]
$DNJ_WOR_Trafgen attach-tracefile $DNJ_WOR_traces
set DNJ_WOR_agent [new Agent]
set WOR_DNJ_agent [new Agent/Null]
$DNJ_WOR_Trafgen attach-agent $DNJ_WOR_agent
$ns attach-agent $DNJ_dom $DNJ_WOR_agent
$ns attach-agent $WOR_dom $WOR_DNJ_agent
$ns connect $DNJ_WOR_agent $WOR_DNJ_agent

$ns at 0.0 "$DNJ_WOR_Trafgen start" 

set DNJ_PYM_traces [new Network/Pcap/File]
$DNJ_PYM_traces open 0 nlanr.DNJ.PYM.raw
set DNJ_PYM_Trafgen [new Application/Traffic/TcpDump]
$DNJ_PYM_Trafgen attach-tracefile $DNJ_PYM_traces
set DNJ_PYM_agent [new Agent]
set PYM_DNJ_agent [new Agent/Null]
$DNJ_PYM_Trafgen attach-agent $DNJ_PYM_agent
$ns attach-agent $DNJ_dom $DNJ_PYM_agent
$ns attach-agent $PYM_dom $PYM_DNJ_agent
$ns connect $DNJ_PYM_agent $PYM_DNJ_agent

$ns at 0.0 "$DNJ_PYM_Trafgen start" 

#Traffic from DNG:
set DNG_AST_traces [new Network/Pcap/File]
$DNG_AST_traces open 0 nlanr.DNG.AST.raw
set DNG_AST_Trafgen [new Application/Traffic/TcpDump]
$DNG_AST_Trafgen attach-tracefile $DNG_AST_traces
set DNG_AST_agent [new Agent]
set AST_DNG_agent [new Agent/Null]
$DNG_AST_Trafgen attach-agent $DNG_AST_agent
$ns attach-agent $DNG_dom $DNG_AST_agent
$ns attach-agent $AST_dom $AST_DNG_agent
$ns connect $DNG_AST_agent $AST_DNG_agent

$ns at 0.0 "$DNG_AST_Trafgen start" 

set DNG_HSJ_traces [new Network/Pcap/File]
$DNG_HSJ_traces open 0 nlanr.DNG.HSJ.raw
set DNG_HSJ_Trafgen [new Application/Traffic/TcpDump]
$DNG_HSJ_Trafgen attach-tracefile $DNG_HSJ_traces
set DNG_HSJ_agent [new Agent]
set HSJ_DNG_agent [new Agent/Null]
$DNG_HSJ_Trafgen attach-agent $DNG_HSJ_agent
$ns attach-agent $DNG_dom $DNG_HSJ_agent
$ns attach-agent $HSJ_dom $HSJ_DNG_agent
$ns connect $DNG_HSJ_agent $HSJ_DNG_agent

$ns at 0.0 "$DNG_HSJ_Trafgen start" 

set DNG_RTO_traces [new Network/Pcap/File]
$DNG_RTO_traces open 0 nlanr.DNG.RTO.raw
set DNG_RTO_Trafgen [new Application/Traffic/TcpDump]
$DNG_RTO_Trafgen attach-tracefile $DNG_RTO_traces
set DNG_RTO_agent [new Agent]
set RTO_DNG_agent [new Agent/Null]
$DNG_RTO_Trafgen attach-agent $DNG_RTO_agent
$ns attach-agent $DNG_dom $DNG_RTO_agent
$ns attach-agent $RTO_dom $RTO_DNG_agent
$ns connect $DNG_RTO_agent $RTO_DNG_agent

$ns at 0.0 "$DNG_RTO_Trafgen start" 

set DNG_HAY_traces [new Network/Pcap/File]
$DNG_HAY_traces open 0 nlanr.DNG.HAY.raw
set DNG_HAY_Trafgen [new Application/Traffic/TcpDump]
$DNG_HAY_Trafgen attach-tracefile $DNG_HAY_traces
set DNG_HAY_agent [new Agent]
set HAY_DNG_agent [new Agent/Null]
$DNG_HAY_Trafgen attach-agent $DNG_HAY_agent
$ns attach-agent $DNG_dom $DNG_HAY_agent
$ns attach-agent $HAY_dom $HAY_DNG_agent
$ns connect $DNG_HAY_agent $HAY_DNG_agent

$ns at 0.0 "$DNG_HAY_Trafgen start" 

set DNG_DNJ_traces [new Network/Pcap/File]
$DNG_DNJ_traces open 0 nlanr.DNG.DNJ.raw
set DNG_DNJ_Trafgen [new Application/Traffic/TcpDump]
$DNG_DNJ_Trafgen attach-tracefile $DNG_DNJ_traces
set DNG_DNJ_agent [new Agent]
set DNJ_DNG_agent [new Agent/Null]
$DNG_DNJ_Trafgen attach-agent $DNG_DNJ_agent
$ns attach-agent $DNG_dom $DNG_DNJ_agent
$ns attach-agent $DNJ_dom $DNJ_DNG_agent
$ns connect $DNG_DNJ_agent $DNJ_DNG_agent

$ns at 0.0 "$DNG_DNJ_Trafgen start" 

set DNG_NOR_traces [new Network/Pcap/File]
$DNG_NOR_traces open 0 nlanr.DNG.NOR.raw
set DNG_NOR_Trafgen [new Application/Traffic/TcpDump]
$DNG_NOR_Trafgen attach-tracefile $DNG_NOR_traces
set DNG_NOR_agent [new Agent]
set NOR_DNG_agent [new Agent/Null]
$DNG_NOR_Trafgen attach-agent $DNG_NOR_agent
$ns attach-agent $DNG_dom $DNG_NOR_agent
$ns attach-agent $NOR_dom $NOR_DNG_agent
$ns connect $DNG_NOR_agent $NOR_DNG_agent

$ns at 0.0 "$DNG_NOR_Trafgen start" 

set DNG_WOR_traces [new Network/Pcap/File]
$DNG_WOR_traces open 0 nlanr.DNG.WOR.raw
set DNG_WOR_Trafgen [new Application/Traffic/TcpDump]
$DNG_WOR_Trafgen attach-tracefile $DNG_WOR_traces
set DNG_WOR_agent [new Agent]
set WOR_DNG_agent [new Agent/Null]
$DNG_WOR_Trafgen attach-agent $DNG_WOR_agent
$ns attach-agent $DNG_dom $DNG_WOR_agent
$ns attach-agent $WOR_dom $WOR_DNG_agent
$ns connect $DNG_WOR_agent $WOR_DNG_agent

$ns at 0.0 "$DNG_WOR_Trafgen start" 

set DNG_PYM_traces [new Network/Pcap/File]
$DNG_PYM_traces open 0 nlanr.DNG.PYM.raw
set DNG_PYM_Trafgen [new Application/Traffic/TcpDump]
$DNG_PYM_Trafgen attach-tracefile $DNG_PYM_traces
set DNG_PYM_agent [new Agent]
set PYM_DNG_agent [new Agent/Null]
$DNG_PYM_Trafgen attach-agent $DNG_PYM_agent
$ns attach-agent $DNG_dom $DNG_PYM_agent
$ns attach-agent $PYM_dom $PYM_DNG_agent
$ns connect $DNG_PYM_agent $PYM_DNG_agent

$ns at 0.0 "$DNG_PYM_Trafgen start" 

#Traffic from NOR:
set NOR_AST_traces [new Network/Pcap/File]
$NOR_AST_traces open 0 nlanr.NOR.AST.raw
set NOR_AST_Trafgen [new Application/Traffic/TcpDump]
$NOR_AST_Trafgen attach-tracefile $NOR_AST_traces
set NOR_AST_agent [new Agent]
set AST_NOR_agent [new Agent/Null]
$NOR_AST_Trafgen attach-agent $NOR_AST_agent
$ns attach-agent $NOR_dom $NOR_AST_agent
$ns attach-agent $AST_dom $AST_NOR_agent
$ns connect $NOR_AST_agent $AST_NOR_agent

$ns at 0.0 "$NOR_AST_Trafgen start" 

set NOR_HSJ_traces [new Network/Pcap/File]
$NOR_HSJ_traces open 0 nlanr.NOR.HSJ.raw
set NOR_HSJ_Trafgen [new Application/Traffic/TcpDump]
$NOR_HSJ_Trafgen attach-tracefile $NOR_HSJ_traces
set NOR_HSJ_agent [new Agent]
set HSJ_NOR_agent [new Agent/Null]
$NOR_HSJ_Trafgen attach-agent $NOR_HSJ_agent
$ns attach-agent $NOR_dom $NOR_HSJ_agent
$ns attach-agent $HSJ_dom $HSJ_NOR_agent
$ns connect $NOR_HSJ_agent $HSJ_NOR_agent

$ns at 0.0 "$NOR_HSJ_Trafgen start" 

set NOR_RTO_traces [new Network/Pcap/File]
$NOR_RTO_traces open 0 nlanr.NOR.RTO.raw
set NOR_RTO_Trafgen [new Application/Traffic/TcpDump]
$NOR_RTO_Trafgen attach-tracefile $NOR_RTO_traces
set NOR_RTO_agent [new Agent]
set RTO_NOR_agent [new Agent/Null]
$NOR_RTO_Trafgen attach-agent $NOR_RTO_agent
$ns attach-agent $NOR_dom $NOR_RTO_agent
$ns attach-agent $RTO_dom $RTO_NOR_agent
$ns connect $NOR_RTO_agent $RTO_NOR_agent

$ns at 0.0 "$NOR_RTO_Trafgen start" 

set NOR_HAY_traces [new Network/Pcap/File]
$NOR_HAY_traces open 0 nlanr.NOR.HAY.raw
set NOR_HAY_Trafgen [new Application/Traffic/TcpDump]
$NOR_HAY_Trafgen attach-tracefile $NOR_HAY_traces
set NOR_HAY_agent [new Agent]
set HAY_NOR_agent [new Agent/Null]
$NOR_HAY_Trafgen attach-agent $NOR_HAY_agent
$ns attach-agent $NOR_dom $NOR_HAY_agent
$ns attach-agent $HAY_dom $HAY_NOR_agent
$ns connect $NOR_HAY_agent $HAY_NOR_agent

$ns at 0.0 "$NOR_HAY_Trafgen start" 

set NOR_DNJ_traces [new Network/Pcap/File]
$NOR_DNJ_traces open 0 nlanr.NOR.DNJ.raw
set NOR_DNJ_Trafgen [new Application/Traffic/TcpDump]
$NOR_DNJ_Trafgen attach-tracefile $NOR_DNJ_traces
set NOR_DNJ_agent [new Agent]
set DNJ_NOR_agent [new Agent/Null]
$NOR_DNJ_Trafgen attach-agent $NOR_DNJ_agent
$ns attach-agent $NOR_dom $NOR_DNJ_agent
$ns attach-agent $DNJ_dom $DNJ_NOR_agent
$ns connect $NOR_DNJ_agent $DNJ_NOR_agent

$ns at 0.0 "$NOR_DNJ_Trafgen start" 

set NOR_DNG_traces [new Network/Pcap/File]
$NOR_DNG_traces open 0 nlanr.NOR.DNG.raw
set NOR_DNG_Trafgen [new Application/Traffic/TcpDump]
$NOR_DNG_Trafgen attach-tracefile $NOR_DNG_traces
set NOR_DNG_agent [new Agent]
set DNG_NOR_agent [new Agent/Null]
$NOR_DNG_Trafgen attach-agent $NOR_DNG_agent
$ns attach-agent $NOR_dom $NOR_DNG_agent
$ns attach-agent $DNG_dom $DNG_NOR_agent
$ns connect $NOR_DNG_agent $DNG_NOR_agent

$ns at 0.0 "$NOR_DNG_Trafgen start" 

set NOR_WOR_traces [new Network/Pcap/File]
$NOR_WOR_traces open 0 nlanr.NOR.WOR.raw
set NOR_WOR_Trafgen [new Application/Traffic/TcpDump]
$NOR_WOR_Trafgen attach-tracefile $NOR_WOR_traces
set NOR_WOR_agent [new Agent]
set WOR_NOR_agent [new Agent/Null]
$NOR_WOR_Trafgen attach-agent $NOR_WOR_agent
$ns attach-agent $NOR_dom $NOR_WOR_agent
$ns attach-agent $WOR_dom $WOR_NOR_agent
$ns connect $NOR_WOR_agent $WOR_NOR_agent

$ns at 0.0 "$NOR_WOR_Trafgen start" 

set NOR_PYM_traces [new Network/Pcap/File]
$NOR_PYM_traces open 0 nlanr.NOR.PYM.raw
set NOR_PYM_Trafgen [new Application/Traffic/TcpDump]
$NOR_PYM_Trafgen attach-tracefile $NOR_PYM_traces
set NOR_PYM_agent [new Agent]
set PYM_NOR_agent [new Agent/Null]
$NOR_PYM_Trafgen attach-agent $NOR_PYM_agent
$ns attach-agent $NOR_dom $NOR_PYM_agent
$ns attach-agent $PYM_dom $PYM_NOR_agent
$ns connect $NOR_PYM_agent $PYM_NOR_agent

$ns at 0.0 "$NOR_PYM_Trafgen start" 

#Traffic from WOR:
set WOR_AST_traces [new Network/Pcap/File]
$WOR_AST_traces open 0 nlanr.WOR.AST.raw
set WOR_AST_Trafgen [new Application/Traffic/TcpDump]
$WOR_AST_Trafgen attach-tracefile $WOR_AST_traces
set WOR_AST_agent [new Agent]
set AST_WOR_agent [new Agent/Null]
$WOR_AST_Trafgen attach-agent $WOR_AST_agent
$ns attach-agent $WOR_dom $WOR_AST_agent
$ns attach-agent $AST_dom $AST_WOR_agent
$ns connect $WOR_AST_agent $AST_WOR_agent

$ns at 0.0 "$WOR_AST_Trafgen start" 

set WOR_HSJ_traces [new Network/Pcap/File]
$WOR_HSJ_traces open 0 nlanr.WOR.HSJ.raw
set WOR_HSJ_Trafgen [new Application/Traffic/TcpDump]
$WOR_HSJ_Trafgen attach-tracefile $WOR_HSJ_traces
set WOR_HSJ_agent [new Agent]
set HSJ_WOR_agent [new Agent/Null]
$WOR_HSJ_Trafgen attach-agent $WOR_HSJ_agent
$ns attach-agent $WOR_dom $WOR_HSJ_agent
$ns attach-agent $HSJ_dom $HSJ_WOR_agent
$ns connect $WOR_HSJ_agent $HSJ_WOR_agent

$ns at 0.0 "$WOR_HSJ_Trafgen start" 

set WOR_RTO_traces [new Network/Pcap/File]
$WOR_RTO_traces open 0 nlanr.WOR.RTO.raw
set WOR_RTO_Trafgen [new Application/Traffic/TcpDump]
$WOR_RTO_Trafgen attach-tracefile $WOR_RTO_traces
set WOR_RTO_agent [new Agent]
set RTO_WOR_agent [new Agent/Null]
$WOR_RTO_Trafgen attach-agent $WOR_RTO_agent
$ns attach-agent $WOR_dom $WOR_RTO_agent
$ns attach-agent $RTO_dom $RTO_WOR_agent
$ns connect $WOR_RTO_agent $RTO_WOR_agent

$ns at 0.0 "$WOR_RTO_Trafgen start" 

set WOR_HAY_traces [new Network/Pcap/File]
$WOR_HAY_traces open 0 nlanr.WOR.HAY.raw
set WOR_HAY_Trafgen [new Application/Traffic/TcpDump]
$WOR_HAY_Trafgen attach-tracefile $WOR_HAY_traces
set WOR_HAY_agent [new Agent]
set HAY_WOR_agent [new Agent/Null]
$WOR_HAY_Trafgen attach-agent $WOR_HAY_agent
$ns attach-agent $WOR_dom $WOR_HAY_agent
$ns attach-agent $HAY_dom $HAY_WOR_agent
$ns connect $WOR_HAY_agent $HAY_WOR_agent

$ns at 0.0 "$WOR_HAY_Trafgen start" 

set WOR_DNJ_traces [new Network/Pcap/File]
$WOR_DNJ_traces open 0 nlanr.WOR.DNJ.raw
set WOR_DNJ_Trafgen [new Application/Traffic/TcpDump]
$WOR_DNJ_Trafgen attach-tracefile $WOR_DNJ_traces
set WOR_DNJ_agent [new Agent]
set DNJ_WOR_agent [new Agent/Null]
$WOR_DNJ_Trafgen attach-agent $WOR_DNJ_agent
$ns attach-agent $WOR_dom $WOR_DNJ_agent
$ns attach-agent $DNJ_dom $DNJ_WOR_agent
$ns connect $WOR_DNJ_agent $DNJ_WOR_agent

$ns at 0.0 "$WOR_DNJ_Trafgen start" 

set WOR_DNG_traces [new Network/Pcap/File]
$WOR_DNG_traces open 0 nlanr.WOR.DNG.raw
set WOR_DNG_Trafgen [new Application/Traffic/TcpDump]
$WOR_DNG_Trafgen attach-tracefile $WOR_DNG_traces
set WOR_DNG_agent [new Agent]
set DNG_WOR_agent [new Agent/Null]
$WOR_DNG_Trafgen attach-agent $WOR_DNG_agent
$ns attach-agent $WOR_dom $WOR_DNG_agent
$ns attach-agent $DNG_dom $DNG_WOR_agent
$ns connect $WOR_DNG_agent $DNG_WOR_agent

$ns at 0.0 "$WOR_DNG_Trafgen start" 

set WOR_NOR_traces [new Network/Pcap/File]
$WOR_NOR_traces open 0 nlanr.WOR.NOR.raw
set WOR_NOR_Trafgen [new Application/Traffic/TcpDump]
$WOR_NOR_Trafgen attach-tracefile $WOR_NOR_traces
set WOR_NOR_agent [new Agent]
set NOR_WOR_agent [new Agent/Null]
$WOR_NOR_Trafgen attach-agent $WOR_NOR_agent
$ns attach-agent $WOR_dom $WOR_NOR_agent
$ns attach-agent $NOR_dom $NOR_WOR_agent
$ns connect $WOR_NOR_agent $NOR_WOR_agent

$ns at 0.0 "$WOR_NOR_Trafgen start" 

set WOR_PYM_traces [new Network/Pcap/File]
$WOR_PYM_traces open 0 nlanr.WOR.PYM.raw
set WOR_PYM_Trafgen [new Application/Traffic/TcpDump]
$WOR_PYM_Trafgen attach-tracefile $WOR_PYM_traces
set WOR_PYM_agent [new Agent]
set PYM_WOR_agent [new Agent/Null]
$WOR_PYM_Trafgen attach-agent $WOR_PYM_agent
$ns attach-agent $WOR_dom $WOR_PYM_agent
$ns attach-agent $PYM_dom $PYM_WOR_agent
$ns connect $WOR_PYM_agent $PYM_WOR_agent

$ns at 0.0 "$WOR_PYM_Trafgen start" 

#Traffic from PYM:
set PYM_AST_traces [new Network/Pcap/File]
$PYM_AST_traces open 0 nlanr.PYM.AST.raw
set PYM_AST_Trafgen [new Application/Traffic/TcpDump]
$PYM_AST_Trafgen attach-tracefile $PYM_AST_traces
set PYM_AST_agent [new Agent]
set AST_PYM_agent [new Agent/Null]
$PYM_AST_Trafgen attach-agent $PYM_AST_agent
$ns attach-agent $PYM_dom $PYM_AST_agent
$ns attach-agent $AST_dom $AST_PYM_agent
$ns connect $PYM_AST_agent $AST_PYM_agent

$ns at 0.0 "$PYM_AST_Trafgen start" 

set PYM_HSJ_traces [new Network/Pcap/File]
$PYM_HSJ_traces open 0 nlanr.PYM.HSJ.raw
set PYM_HSJ_Trafgen [new Application/Traffic/TcpDump]
$PYM_HSJ_Trafgen attach-tracefile $PYM_HSJ_traces
set PYM_HSJ_agent [new Agent]
set HSJ_PYM_agent [new Agent/Null]
$PYM_HSJ_Trafgen attach-agent $PYM_HSJ_agent
$ns attach-agent $PYM_dom $PYM_HSJ_agent
$ns attach-agent $HSJ_dom $HSJ_PYM_agent
$ns connect $PYM_HSJ_agent $HSJ_PYM_agent

$ns at 0.0 "$PYM_HSJ_Trafgen start" 

set PYM_RTO_traces [new Network/Pcap/File]
$PYM_RTO_traces open 0 nlanr.PYM.RTO.raw
set PYM_RTO_Trafgen [new Application/Traffic/TcpDump]
$PYM_RTO_Trafgen attach-tracefile $PYM_RTO_traces
set PYM_RTO_agent [new Agent]
set RTO_PYM_agent [new Agent/Null]
$PYM_RTO_Trafgen attach-agent $PYM_RTO_agent
$ns attach-agent $PYM_dom $PYM_RTO_agent
$ns attach-agent $RTO_dom $RTO_PYM_agent
$ns connect $PYM_RTO_agent $RTO_PYM_agent

$ns at 0.0 "$PYM_RTO_Trafgen start" 

set PYM_HAY_traces [new Network/Pcap/File]
$PYM_HAY_traces open 0 nlanr.PYM.HAY.raw
set PYM_HAY_Trafgen [new Application/Traffic/TcpDump]
$PYM_HAY_Trafgen attach-tracefile $PYM_HAY_traces
set PYM_HAY_agent [new Agent]
set HAY_PYM_agent [new Agent/Null]
$PYM_HAY_Trafgen attach-agent $PYM_HAY_agent
$ns attach-agent $PYM_dom $PYM_HAY_agent
$ns attach-agent $HAY_dom $HAY_PYM_agent
$ns connect $PYM_HAY_agent $HAY_PYM_agent

$ns at 0.0 "$PYM_HAY_Trafgen start" 

set PYM_DNJ_traces [new Network/Pcap/File]
$PYM_DNJ_traces open 0 nlanr.PYM.DNJ.raw
set PYM_DNJ_Trafgen [new Application/Traffic/TcpDump]
$PYM_DNJ_Trafgen attach-tracefile $PYM_DNJ_traces
set PYM_DNJ_agent [new Agent]
set DNJ_PYM_agent [new Agent/Null]
$PYM_DNJ_Trafgen attach-agent $PYM_DNJ_agent
$ns attach-agent $PYM_dom $PYM_DNJ_agent
$ns attach-agent $DNJ_dom $DNJ_PYM_agent
$ns connect $PYM_DNJ_agent $DNJ_PYM_agent

$ns at 0.0 "$PYM_DNJ_Trafgen start" 

set PYM_DNG_traces [new Network/Pcap/File]
$PYM_DNG_traces open 0 nlanr.PYM.DNG.raw
set PYM_DNG_Trafgen [new Application/Traffic/TcpDump]
$PYM_DNG_Trafgen attach-tracefile $PYM_DNG_traces
set PYM_DNG_agent [new Agent]
set DNG_PYM_agent [new Agent/Null]
$PYM_DNG_Trafgen attach-agent $PYM_DNG_agent
$ns attach-agent $PYM_dom $PYM_DNG_agent
$ns attach-agent $DNG_dom $DNG_PYM_agent
$ns connect $PYM_DNG_agent $DNG_PYM_agent

$ns at 0.0 "$PYM_DNG_Trafgen start" 

set PYM_NOR_traces [new Network/Pcap/File]
$PYM_NOR_traces open 0 nlanr.PYM.NOR.raw
set PYM_NOR_Trafgen [new Application/Traffic/TcpDump]
$PYM_NOR_Trafgen attach-tracefile $PYM_NOR_traces
set PYM_NOR_agent [new Agent]
set NOR_PYM_agent [new Agent/Null]
$PYM_NOR_Trafgen attach-agent $PYM_NOR_agent
$ns attach-agent $PYM_dom $PYM_NOR_agent
$ns attach-agent $NOR_dom $NOR_PYM_agent
$ns connect $PYM_NOR_agent $NOR_PYM_agent

$ns at 0.0 "$PYM_NOR_Trafgen start" 

set PYM_WOR_traces [new Network/Pcap/File]
$PYM_WOR_traces open 0 nlanr.PYM.WOR.raw
set PYM_WOR_Trafgen [new Application/Traffic/TcpDump]
$PYM_WOR_Trafgen attach-tracefile $PYM_WOR_traces
set PYM_WOR_agent [new Agent]
set WOR_PYM_agent [new Agent/Null]
$PYM_WOR_Trafgen attach-agent $PYM_WOR_agent
$ns attach-agent $PYM_dom $PYM_WOR_agent
$ns attach-agent $WOR_dom $WOR_PYM_agent
$ns connect $PYM_WOR_agent $WOR_PYM_agent

$ns at 0.0 "$PYM_WOR_Trafgen start" 


proc finish {} {
    global ns tf nf num_of_switches switch
    $ns flush-trace
#    close $tf
#    close $nf
    set nodeslist [$ns all-nodes-list]
    foreach node $nodeslist {
	if {[$node info class] == "SwiftNode"} {
	    $node dump-stats
	}
    }
#    puts "running nam..."
#    exec nam nam.tr &
    set nodeslist [$ns all-nodes-list]
    foreach node $nodeslist {
	set agentlist [$node agents]
    	foreach agent $agentlist {
		if {[$agent info class] == "Agent/Null"} {
			$agent dump-stats
		}
	}
    }
    exit 0
}

$ns at $run_time "finish"



# install SWAP on all switch node
set nodeslist [$ns all-nodes-list]
set i 0
foreach node $nodeslist {
    if {[$node info class] == "SwiftNode"} {
	foreach nbr [$node neighbors] {
	    if [info exists swap($node:$nbr)] continue;
		set l1 [$ns link $node $nbr ]
		set h1 [$l1 set head_]
		set l2 [$ns link $nbr $node ]
		set h2 [$l2 set head_]

	    set analyzer1 [$node set flow_analyzer_]
	    if {[$nbr info class] == "SwiftNode"} {
		set swap($node:$nbr) [new Agent/SWAP]
		$swap($node:$nbr) analyzer $analyzer1
		set analyzer2 [$nbr set flow_analyzer_]
		set swap($nbr:$node) [new Agent/SWAP]
		$swap($nbr:$node) analyzer $analyzer2
		$ns attach-agent $node $swap($node:$nbr)
		$ns attach-agent $nbr $swap($nbr:$node)
	
#		$analyzer1 agent $swap($node:$nbr)
#		$analyzer2 agent $swap($nbr:$node)



      		$analyzer1 add-agent $h1 $swap($node:$nbr)
		$analyzer1 add-agent $h2 $swap($node:$nbr)
		$analyzer2 add-agent $h1 $swap($nbr:$node)
		$analyzer2 add-agent $h2 $swap($nbr:$node)



		$ns connect $swap($node:$nbr) $swap($nbr:$node)
	    } else {
			$analyzer1 no-agent $h1
		        $analyzer1 no-agent $h2
	    }
	}
    }
}




$ns run



